package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.context.VariableContext;
import org.bitbucket.bradleysmithllc.etlunit.parser.*;

import javax.annotation.Nullable;

public interface ClassListener extends OperationProcessor
{
	void beginPackage(String name, VariableContext context) throws TestAssertionFailure, TestExecutionError, TestWarning;
	void begin(ETLTestClass cl, VariableContext context) throws TestAssertionFailure, TestExecutionError, TestWarning;

	void declare(ETLTestVariable var, VariableContext context);

	void begin(ETLTestMethod mt, VariableContext context) throws TestAssertionFailure, TestExecutionError, TestWarning;

	/**
	 *
	 * @param mt - the method about to be processed.  May differ from the test the operation belongs
	 *           to in the case this operation is in a before or after test method.  Null for
	 *           before and after class methods.
	 * @param op
	 * @param parameters
	 * @param vcontext
	 * @param econtext
	 * @throws TestAssertionFailure
	 * @throws TestExecutionError
	 * @throws TestWarning
	 */
	void begin(@Nullable ETLTestMethod mt, ETLTestOperation op, ETLTestValueObject parameters, VariableContext vcontext, ExecutionContext econtext)
			throws TestAssertionFailure, TestExecutionError, TestWarning;

	void end(@Nullable ETLTestMethod mt, ETLTestOperation op, ETLTestValueObject parameters, VariableContext vcontext, ExecutionContext econtext)
			throws TestAssertionFailure, TestExecutionError, TestWarning;

	void end(ETLTestMethod mt, VariableContext context) throws TestAssertionFailure, TestExecutionError, TestWarning;

	void end(ETLTestClass cl, VariableContext context) throws TestAssertionFailure, TestExecutionError, TestWarning;
}